#include <fcntl.h> // O_WRONLY...
#include <stdio.h> // printf
#include <stdlib.h> // atoi
#include <string.h> // strcmp
#include <unistd.h> // close
#include <sys/wait.h> // wait
#include <time.h> // time
#include "ipc.h"
#include "common.h"
#include "pa1.h"
#include "internal.h"

typedef struct {
  int fd_write;
  int fd_read;
} __attribute__((packed)) pipe_fd;


void pipe_work(local_id id);
void parent_work();
int check_args(int argc, char * argv[]);
void open_pipes();
void close_redundant_pipes(local_id id);
void close_self_pipes(local_id id);
void synchronize_other_start(local_id id);
void computation(local_id id);
void synchronize_other_done(local_id id);
int f_index(int i, int j);
pipe_fd * get_struct(int from, int to);
void log_error(int err_num);

// @param num_event:
//  case 0: log_startet
//  case 1: log_recieved_all_started
//  case 2: log_done
//  case 3: log_recieved_all_done
// @param l_id    local process id
void log_event(int num_event, local_id l_id);

// @param num_event:
//  case 0: pipe_opend
//  case 1: pipe_closed
// @param from    local process id, that has write descriptor
// @param to      local process id, that has read descriptor
void log_pipe(int num_event, int from, int to);
void wait_children();
